Index: trunk/source/App/TAppDecoder/TAppDecCfg.cpp
===================================================================
--- trunk/source/App/TAppDecoder/TAppDecCfg.cpp	(revision 55)
+++ trunk/source/App/TAppDecoder/TAppDecCfg.cpp	(revision 125)
@@ -4,5 +4,5 @@
  * granted under this license.  
  *
- * Copyright (c) 2010-2012, ITU/ISO/IEC
+ * Copyright (c) 2010-2013, ITU/ISO/IEC
  * All rights reserved.
  *
@@ -64,5 +64,5 @@
 Bool TAppDecCfg::parseCfg( Int argc, Char* argv[] )
 {
-  bool do_help = false;
+  Bool do_help = false;
   string cfg_BitstreamFile;
 #if SVC_EXTENSION
@@ -78,7 +78,5 @@
   string cfg_BLSyntaxFile;
 #endif
-#if TARGET_DECLAYERID_SET
   string cfg_TargetDecLayerIdSetFile;
-#endif
 
   po::Options opts;
@@ -108,22 +106,21 @@
 #endif
   ("SkipFrames,s", m_iSkipFrame, 0, "number of frames to skip before random access")
-  ("OutputBitDepth,d", m_outputBitDepth, 0u, "bit depth of YUV output file (use 0 for native depth)")
+  ("OutputBitDepth,d", m_outputBitDepthY, 0, "bit depth of YUV output luma component (default: use 0 for native depth)")
+  ("OutputBitDepthC,d", m_outputBitDepthC, 0, "bit depth of YUV output chroma component (default: use 0 for native depth)")
 #if SVC_EXTENSION
   ("LayerNum,-ls", nLayerNum, 1, "Number of layers to be decoded.")
 #endif 
   ("MaxTemporalLayer,t", m_iMaxTemporalLayer, -1, "Maximum Temporal Layer to be decoded. -1 to decode all layers")
-  ("SEIpictureDigest", m_decodedPictureHashSEIEnabled, 1, "Control handling of decoded picture hash SEI messages\n"
-                                              "\t3: checksum\n"
-                                              "\t2: CRC\n"
-                                              "\t1: MD5\n"
-                                              "\t0: ignore")
-#if TARGET_DECLAYERID_SET
+  ("SEIDecodedPictureHash", m_decodedPictureHashSEIEnabled, 1, "Control handling of decoded picture hash SEI messages\n"
+                                              "\t1: check hash in SEI messages if available in the bitstream\n"
+                                              "\t0: ignore SEI message")
+  ("SEIpictureDigest", m_decodedPictureHashSEIEnabled, 1, "deprecated alias for SEIDecodedPictureHash")
   ("TarDecLayerIdSetFile,l", cfg_TargetDecLayerIdSetFile, string(""), "targetDecLayerIdSet file name. The file should include white space separated LayerId values to be decoded. Omitting the option or a value of -1 in the file decodes all layers.")
-#endif
+  ("RespectDefDispWindow,w", m_respectDefDispWindow, 0, "Only output content inside the default display window\n")
   ;
   po::setDefaults(opts);
-  const list<const char*>& argv_unhandled = po::scanArgv(opts, argc, (const char**) argv);
-
-  for (list<const char*>::const_iterator it = argv_unhandled.begin(); it != argv_unhandled.end(); it++)
+  const list<const Char*>& argv_unhandled = po::scanArgv(opts, argc, (const Char**) argv);
+
+  for (list<const Char*>::const_iterator it = argv_unhandled.begin(); it != argv_unhandled.end(); it++)
   {
     fprintf(stderr, "Unhandled argument ignored: `%s'\n", *it);
@@ -161,5 +158,4 @@
   }
 
-#if TARGET_DECLAYERID_SET
   if ( !cfg_TargetDecLayerIdSetFile.empty() )
   {
@@ -206,5 +202,4 @@
     }
   }
-#endif
 
   return true;
Index: trunk/source/App/TAppDecoder/TAppDecCfg.h
===================================================================
--- trunk/source/App/TAppDecoder/TAppDecCfg.h	(revision 55)
+++ trunk/source/App/TAppDecoder/TAppDecCfg.h	(revision 125)
@@ -4,5 +4,5 @@
  * granted under this license.  
  *
- * Copyright (c) 2010-2012, ITU/ISO/IEC
+ * Copyright (c) 2010-2013, ITU/ISO/IEC
  * All rights reserved.
  *
@@ -44,7 +44,5 @@
 
 #include "TLibCommon/CommonDef.h"
-#if TARGET_DECLAYERID_SET
 #include <vector>
-#endif
 
 //! \ingroup TAppDecoder
@@ -59,20 +57,20 @@
 {
 protected:
-  char*         m_pchBitstreamFile;                   ///< input bitstream file name
+  Char*         m_pchBitstreamFile;                   ///< input bitstream file name
 #if SVC_EXTENSION
-  char*         m_pchReconFile [MAX_LAYERS];          ///< output reconstruction file name
+  Char*         m_pchReconFile [MAX_LAYERS];          ///< output reconstruction file name
 #if AVC_BASE
-  char*         m_pchBLReconFile;                     ///< input BL reconstruction file name
+  Char*         m_pchBLReconFile;                     ///< input BL reconstruction file name
   Int           m_iBLSourceWidth;
   Int           m_iBLSourceHeight;
 #if AVC_SYNTAX
-  char*         m_pchBLSyntaxFile;                     ///< input BL syntax file name  
+  Char*         m_pchBLSyntaxFile;                     ///< input BL syntax file name  
 #endif
 #endif
 #else
-  char*         m_pchReconFile;                       ///< output reconstruction file name
+  Char*         m_pchReconFile;                       ///< output reconstruction file name
 #endif
 #if SYNTAX_OUTPUT
-  char*         m_pchBLSyntaxFile;                     ///< input BL syntax file name
+  Char*         m_pchBLSyntaxFile;                     ///< input BL syntax file name
   Int           m_iBLSourceWidth;
   Int           m_iBLSourceHeight;
@@ -80,5 +78,6 @@
 #endif
   Int           m_iSkipFrame;                         ///< counter for frames prior to the random access point to skip
-  UInt          m_outputBitDepth;                     ///< bit depth used for writing output
+  Int           m_outputBitDepthY;                     ///< bit depth used for writing output (luma)
+  Int           m_outputBitDepthC;                     ///< bit depth used for writing output (chroma)t
 
   Int           m_iMaxTemporalLayer;                  ///< maximum temporal layer to be decoded
@@ -88,11 +87,32 @@
   Int           m_tgtLayerId;                        ///< target layer ID
 #endif
+  std::vector<Int> m_targetDecLayerIdSet;             ///< set of LayerIds to be included in the sub-bitstream extraction process.
+  Int           m_respectDefDispWindow;               ///< Only output content inside the default display window 
 
-#if TARGET_DECLAYERID_SET
-  std::vector<Int> m_targetDecLayerIdSet;             ///< set of LayerIds to be included in the sub-bitstream extraction process.
+public:
+  TAppDecCfg()
+  : m_pchBitstreamFile(NULL)
+#if !SVC_EXTENSION
+  , m_pchReconFile(NULL) 
 #endif
-  
-public:
-  TAppDecCfg()          {}
+  , m_iSkipFrame(0)
+  , m_outputBitDepthY(0)
+  , m_outputBitDepthC(0)
+  , m_iMaxTemporalLayer(-1)
+  , m_decodedPictureHashSEIEnabled(0)
+#if SVC_EXTENSION
+  , m_tgtLayerId(0)
+#endif
+  , m_respectDefDispWindow(0)
+#if AVC_BASE
+  , m_iBLSourceWidth(0)
+  , m_iBLSourceHeight(0)
+#endif
+#if SYNTAX_OUTPUT
+  , m_iBLSourceWidth(0)
+  , m_iBLSourceHeight(0)
+  , m_iBLFrames(0)
+#endif
+  {}
   virtual ~TAppDecCfg() {}
   
Index: trunk/source/App/TAppDecoder/TAppDecTop.cpp
===================================================================
--- trunk/source/App/TAppDecoder/TAppDecTop.cpp	(revision 55)
+++ trunk/source/App/TAppDecoder/TAppDecTop.cpp	(revision 125)
@@ -4,5 +4,5 @@
  * granted under this license.  
  *
- * Copyright (c) 2010-2012, ITU/ISO/IEC
+ * Copyright (c) 2010-2013, ITU/ISO/IEC
  * All rights reserved.
  *
@@ -53,8 +53,8 @@
 // ====================================================================================================================
 
+#if SVC_EXTENSION
 TAppDecTop::TAppDecTop()
 {
   ::memset (m_abDecFlag, 0, sizeof (m_abDecFlag));
-#if SVC_EXTENSION
   for(UInt layer=0; layer < MAX_LAYERS; layer++)
   {
@@ -62,9 +62,12 @@
     m_apcTDecTop[layer] = &m_acTDecTop[layer];
   }
-#else
-  m_iPOCLastDisplay  = -MAX_INT;
-#endif
-
-}
+}
+#else
+TAppDecTop::TAppDecTop()
+: m_iPOCLastDisplay(-MAX_INT)
+{
+  ::memset (m_abDecFlag, 0, sizeof (m_abDecFlag));
+}
+#endif
 
 Void TAppDecTop::create()
@@ -126,5 +129,5 @@
 Void TAppDecTop::decode()
 {
-  UInt                uiPOC;
+  Int                poc;
   TComList<TComPic*>* pcListPic = NULL;
 
@@ -143,5 +146,5 @@
 
   // main decoder loop
-  bool recon_opened[MAX_LAYERS]; // reconstruction file not yet opened. (must be performed after SPS is seen)
+  Bool recon_opened[MAX_LAYERS]; // reconstruction file not yet opened. (must be performed after SPS is seen)
   for(UInt layer=0; layer<=m_tgtLayerId; layer++)
   {
@@ -200,6 +203,6 @@
 
     // call actual decoding function
-    bool bNewPicture = false;
-    bool bNewPOC = false;
+    Bool bNewPicture = false;
+    Bool bNewPOC = false;
     if (nalUnit.empty())
     {
@@ -214,11 +217,6 @@
     {
       read(nalu, nalUnit);
-#if TARGET_DECLAYERID_SET
       if( (m_iMaxTemporalLayer >= 0 && nalu.m_temporalId > m_iMaxTemporalLayer) || !isNaluWithinTargetDecLayerIdSet(&nalu)  ||
         (nalu.m_layerId > m_tgtLayerId) )
-#else
-      if(m_iMaxTemporalLayer >= 0 && nalu.m_temporalId > m_iMaxTemporalLayer ||
-        (nalu.m_layerId > m_tgtLayerId) )
-#endif
       {
         bNewPicture = false;
@@ -241,5 +239,5 @@
     if (bNewPicture || !bitstreamFile)
     {
-      m_acTDecTop[curLayerId].executeDeblockAndAlf(uiPOC, pcListPic, m_iSkipFrame, m_aiPOCLastDisplay[curLayerId]);
+      m_acTDecTop[curLayerId].executeLoopFilters(poc, pcListPic);
     }
 
@@ -248,18 +246,15 @@
       if ( m_pchReconFile[curLayerId] && !recon_opened[curLayerId] )
       {
-        if ( m_outputBitDepth == 0 )
-        {
-          m_outputBitDepth = g_uiBitDepth + g_uiBitIncrement;
-        }
-
-        m_acTVideoIOYuvReconFile[curLayerId].open( m_pchReconFile[curLayerId], true, m_outputBitDepth, g_uiBitDepth + g_uiBitIncrement ); // write mode
+        if (!m_outputBitDepthY) { m_outputBitDepthY = g_bitDepthY; }        
+        if (!m_outputBitDepthC) { m_outputBitDepthC = g_bitDepthC; }
+
+        m_acTVideoIOYuvReconFile[curLayerId].open( m_pchReconFile[curLayerId], true, m_outputBitDepthY, m_outputBitDepthC, g_bitDepthY, g_bitDepthC ); // write mode
+
         recon_opened[curLayerId] = true;
       }
       if ( bNewPicture && bNewPOC && 
            (   nalu.m_nalUnitType == NAL_UNIT_CODED_SLICE_IDR
-#if SUPPORT_FOR_RAP_N_LP
             || nalu.m_nalUnitType == NAL_UNIT_CODED_SLICE_IDR_N_LP
             || nalu.m_nalUnitType == NAL_UNIT_CODED_SLICE_BLA_N_LP
-#endif
             || nalu.m_nalUnitType == NAL_UNIT_CODED_SLICE_BLANT
             || nalu.m_nalUnitType == NAL_UNIT_CODED_SLICE_BLA ) )
@@ -306,5 +301,5 @@
 Void TAppDecTop::decode()
 {
-  UInt                uiPOC;
+  Int                 poc;
   TComList<TComPic*>* pcListPic = NULL;
 
@@ -324,5 +319,5 @@
 
   // main decoder loop
-  bool recon_opened = false; // reconstruction file not yet opened. (must be performed after SPS is seen)
+  Bool recon_opened = false; // reconstruction file not yet opened. (must be performed after SPS is seen)
 
 #if SYNTAX_OUTPUT
@@ -355,5 +350,5 @@
     streampos location = bitstreamFile.tellg();
     AnnexBStats stats = AnnexBStats();
-    bool bPreviousPictureDecoded = false;
+    Bool bPreviousPictureDecoded = false;
 
     vector<uint8_t> nalUnit;
@@ -362,5 +357,5 @@
 
     // call actual decoding function
-    bool bNewPicture = false;
+    Bool bNewPicture = false;
     if (nalUnit.empty())
     {
@@ -375,9 +370,5 @@
     {
       read(nalu, nalUnit);
-#if TARGET_DECLAYERID_SET
       if( (m_iMaxTemporalLayer >= 0 && nalu.m_temporalId > m_iMaxTemporalLayer) || !isNaluWithinTargetDecLayerIdSet(&nalu)  )
-#else
-      if(m_iMaxTemporalLayer >= 0 && nalu.m_temporalId > m_iMaxTemporalLayer)
-#endif
       {
         if(bPreviousPictureDecoded)
@@ -409,5 +400,5 @@
     if (bNewPicture || !bitstreamFile)
     {
-      m_cTDecTop.executeDeblockAndAlf(uiPOC, pcListPic, m_iSkipFrame, m_iPOCLastDisplay);
+      m_cTDecTop.executeLoopFilters(poc, pcListPic);
     }
 
@@ -416,18 +407,14 @@
       if ( m_pchReconFile && !recon_opened )
       {
-        if ( m_outputBitDepth == 0 )
-        {
-          m_outputBitDepth = g_uiBitDepth + g_uiBitIncrement;
-        }
-
-        m_cTVideoIOYuvReconFile.open( m_pchReconFile, true, m_outputBitDepth, g_uiBitDepth + g_uiBitIncrement ); // write mode
+        if (!m_outputBitDepthY) { m_outputBitDepthY = g_bitDepthY; }
+        if (!m_outputBitDepthC) { m_outputBitDepthC = g_bitDepthC; }
+
+        m_cTVideoIOYuvReconFile.open( m_pchReconFile, true, m_outputBitDepthY, m_outputBitDepthC, g_bitDepthY, g_bitDepthC ); // write mode
         recon_opened = true;
       }
       if ( bNewPicture && 
            (   nalu.m_nalUnitType == NAL_UNIT_CODED_SLICE_IDR
-#if SUPPORT_FOR_RAP_N_LP
             || nalu.m_nalUnitType == NAL_UNIT_CODED_SLICE_IDR_N_LP
             || nalu.m_nalUnitType == NAL_UNIT_CODED_SLICE_BLA_N_LP
-#endif
             || nalu.m_nalUnitType == NAL_UNIT_CODED_SLICE_BLANT
             || nalu.m_nalUnitType == NAL_UNIT_CODED_SLICE_BLA ) )
@@ -442,5 +429,5 @@
     }
   }
-
+  
 #if SYNTAX_OUTPUT
   if( streamSyntaxFile.is_open() )
@@ -559,10 +546,9 @@
   {
     TComPic* pcPic = *(iterPic);
-    TComSPS *sps = pcPic->getSlice(0)->getSPS();
     
 #if SVC_EXTENSION
-    if ( pcPic->getOutputMark() && (not_displayed >  pcPic->getSlice(0)->getSPS()->getNumReorderPics(tId) && pcPic->getPOC() > m_aiPOCLastDisplay[layerId]))
-#else
-    if ( pcPic->getOutputMark() && (not_displayed >  pcPic->getSlice(0)->getSPS()->getNumReorderPics(tId) && pcPic->getPOC() > m_iPOCLastDisplay))
+    if ( pcPic->getOutputMark() && (not_displayed >  pcPic->getNumReorderPics(tId) && pcPic->getPOC() > m_aiPOCLastDisplay[layerId]))
+#else
+    if ( pcPic->getOutputMark() && (not_displayed >  pcPic->getNumReorderPics(tId) && pcPic->getPOC() > m_iPOCLastDisplay))
 #endif
     {
@@ -572,5 +558,11 @@
       if ( m_pchReconFile[layerId] )
       {
-        m_acTVideoIOYuvReconFile[layerId].write( pcPic->getPicYuvRec(), sps->getPicCropLeftOffset(), sps->getPicCropRightOffset(), sps->getPicCropTopOffset(), sps->getPicCropBottomOffset() );
+        const Window &conf = pcPic->getConformanceWindow();
+        const Window &defDisp = m_respectDefDispWindow ? pcPic->getDefDisplayWindow() : Window();
+        m_acTVideoIOYuvReconFile[layerId].write( pcPic->getPicYuvRec(),
+                                       conf.getWindowLeftOffset() + defDisp.getWindowLeftOffset(),
+                                       conf.getWindowRightOffset() + defDisp.getWindowRightOffset(),
+                                       conf.getWindowTopOffset() + defDisp.getWindowTopOffset(),
+                                       conf.getWindowBottomOffset() + defDisp.getWindowBottomOffset() );
       }
       
@@ -580,5 +572,11 @@
       if ( m_pchReconFile )
       {
-        m_cTVideoIOYuvReconFile.write( pcPic->getPicYuvRec(), sps->getPicCropLeftOffset(), sps->getPicCropRightOffset(), sps->getPicCropTopOffset(), sps->getPicCropBottomOffset() );
+        const Window &conf = pcPic->getConformanceWindow();
+        const Window &defDisp = m_respectDefDispWindow ? pcPic->getDefDisplayWindow() : Window();
+        m_cTVideoIOYuvReconFile.write( pcPic->getPicYuvRec(),
+                                       conf.getWindowLeftOffset() + defDisp.getWindowLeftOffset(),
+                                       conf.getWindowRightOffset() + defDisp.getWindowRightOffset(),
+                                       conf.getWindowTopOffset() + defDisp.getWindowTopOffset(),
+                                       conf.getWindowBottomOffset() + defDisp.getWindowBottomOffset() );
       }
       
@@ -630,5 +628,4 @@
   {
     TComPic* pcPic = *(iterPic);
-    TComSPS *sps = pcPic->getSlice(0)->getSPS();
 
     if ( pcPic->getOutputMark() )
@@ -638,5 +635,11 @@
       if ( m_pchReconFile[layerId] )
       {
-        m_acTVideoIOYuvReconFile[layerId].write( pcPic->getPicYuvRec(), sps->getPicCropLeftOffset(), sps->getPicCropRightOffset(), sps->getPicCropTopOffset(), sps->getPicCropBottomOffset() );
+        const Window &conf = pcPic->getConformanceWindow();
+        const Window &defDisp = m_respectDefDispWindow ? pcPic->getDefDisplayWindow() : Window();
+        m_acTVideoIOYuvReconFile[layerId].write( pcPic->getPicYuvRec(),
+                                       conf.getWindowLeftOffset() + defDisp.getWindowLeftOffset(),
+                                       conf.getWindowRightOffset() + defDisp.getWindowRightOffset(),
+                                       conf.getWindowTopOffset() + defDisp.getWindowTopOffset(),
+                                       conf.getWindowBottomOffset() + defDisp.getWindowBottomOffset() );
       }
       
@@ -646,5 +649,11 @@
       if ( m_pchReconFile )
       {
-        m_cTVideoIOYuvReconFile.write( pcPic->getPicYuvRec(), sps->getPicCropLeftOffset(), sps->getPicCropRightOffset(), sps->getPicCropTopOffset(), sps->getPicCropBottomOffset() );
+        const Window &conf = pcPic->getConformanceWindow();
+        const Window &defDisp = m_respectDefDispWindow ? pcPic->getDefDisplayWindow() : Window();
+        m_cTVideoIOYuvReconFile.write( pcPic->getPicYuvRec(),
+                                       conf.getWindowLeftOffset() + defDisp.getWindowLeftOffset(),
+                                       conf.getWindowRightOffset() + defDisp.getWindowRightOffset(),
+                                       conf.getWindowTopOffset() + defDisp.getWindowTopOffset(),
+                                       conf.getWindowBottomOffset() + defDisp.getWindowBottomOffset() );
       }
       
@@ -679,5 +688,5 @@
       pcPic = NULL;
     }
-#endif
+#endif    
 #endif
     iterPic++;
@@ -686,10 +695,9 @@
   m_aiPOCLastDisplay[layerId] = -MAX_INT;
 #else
-  pcListPic->clear(); //k Cannot be cleared here. Otherwise, pictures will never be destroyed.
+  pcListPic->clear();
   m_iPOCLastDisplay = -MAX_INT;
 #endif
 }
 
-#if TARGET_DECLAYERID_SET
 /** \param nalu Input nalu to check whether its LayerId is within targetDecLayerIdSet
  */
@@ -709,5 +717,4 @@
   return false;
 }
-#endif
 
 //! \}
Index: trunk/source/App/TAppDecoder/TAppDecTop.h
===================================================================
--- trunk/source/App/TAppDecoder/TAppDecTop.h	(revision 55)
+++ trunk/source/App/TAppDecoder/TAppDecTop.h	(revision 125)
@@ -4,5 +4,5 @@
  * granted under this license.  
  *
- * Copyright (c) 2010-2012, ITU/ISO/IEC
+ * Copyright (c) 2010-2013, ITU/ISO/IEC
  * All rights reserved.
  *
@@ -98,7 +98,5 @@
   Void  xFlushOutput      ( TComList<TComPic*>* pcListPic ); ///< flush all remaining decoded pictures to file
 #endif
-#if TARGET_DECLAYERID_SET
   Bool  isNaluWithinTargetDecLayerIdSet ( InputNALUnit* nalu ); ///< check whether given Nalu is within targetDecLayerIdSet
-#endif
 };
 
Index: trunk/source/App/TAppDecoder/decmain.cpp
===================================================================
--- trunk/source/App/TAppDecoder/decmain.cpp	(revision 55)
+++ trunk/source/App/TAppDecoder/decmain.cpp	(revision 125)
@@ -4,5 +4,5 @@
  * granted under this license.  
  *
- * Copyright (c) 2010-2012, ITU/ISO/IEC
+ * Copyright (c) 2010-2013, ITU/ISO/IEC
  * All rights reserved.
  *
